> For the complete documentation index, see [llms.txt](https://docs.kiiglobal.io/docs/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.kiiglobal.io/docs/build-on-kiichain/precompiled-contracts/oracle-precompile.md).

# Oracle Precompile

### **Functions**

| Function Name          | Input Parameters                                    | Return Value                                                                                                                                                  | Description                                                                                        |
| ---------------------- | --------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------- | -------------------------------------------------------------------------------------------------- |
| **`getExchangeRate`**  | `denom: string` (currency denomination)             | <p><code>rate: string</code><br><code>lastUpdate: string</code><br><code>lastUpdateTimestamp: int64</code></p>                                                | Gets the current exchange rate for a specific denomination with update metadata                    |
| **`getExchangeRates`** | None                                                | <p><code>denoms: string\[]</code><br><code>rates: string\[]</code><br><code>lastUpdate: string\[]</code><br><code>lastUpdateTimestamps: uint256\[]</code></p> | Gets exchange rates for all available denominations with update metadata                           |
| **`getTwaps`**         | `lookbackSeconds: uint256` (time window in seconds) | <p><code>denoms: string\[]</code><br><code>twaps: string\[]</code></p>                                                                                        | Gets time-weighted average prices (TWAPs) for all denominations over the specified lookback period |

**Precompile Address**

`0x0000000000000000000000000000000000001003`


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.kiiglobal.io/docs/build-on-kiichain/precompiled-contracts/oracle-precompile.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
